<!--  
   HTML to Docbook DTD transformation by Gary Lawrence Murphy 
   with all the ideas from many other people.  It doesn't work very well
   but it does save some of the grunt work in moving a well-behaved
   HTML file to a format that is DocBook-like.  

   Don't expect miracles. The best metaphor I have seen for what this
   script attempts is "It's like asking for a machine that takes bricks
   and creates houses" whereas the conversion from SGML to HTML is more
   like "taking a house and reducing it to bricks".

   This stylesheet was simply and naively spliced together from comments and
   musings by various authors on the dssslist at mulberrytech.com and a
   large part adapted from the Holy Grail script by cbbrowne@news.hex.net
   (Christopher Browne) I cannot rightly claim copyright and only include
   the license below to clarify the free nature of this work.

   Version: $Id: html2db.dsl,v 1.1.1.1 2000/05/24 18:06:54 garym Exp $
   Created: May 21, 2000
   Maintainer: Gary Lawrence Murphy <garym@teledyn.com>

   USE: jade -t sgml -d html2db.dsl HTMLFILE > SGMLFILE

   NOTE: you need to remove any DTD lines from the start of your HTML

 LICENCE

 This program is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2 of the License, or
 (at your option) any later version.
  
 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.
  
 You should have received a copy of the GNU General Public License
 along with this program; if not, write to the Free Software
 Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

-->

<!DOCTYPE style-sheet PUBLIC "-//James Clark//DTD DSSSL Style Sheet//EN">
<style-sheet>

<style-specification id="html2sgml">
<style-specification-body> 


(define debug
  (external-procedure "UNREGISTERED::James Clark//Procedure::debug"))

(declare-flow-object-class element
  "UNREGISTERED::James Clark//Flow Object Class::element")
(declare-flow-object-class empty-element
  "UNREGISTERED::James Clark//Flow Object Class::empty-element")
(declare-flow-object-class document-type
  "UNREGISTERED::James Clark//Flow Object Class::document-type")
(declare-flow-object-class processing-instruction
  "UNREGISTERED::James Clark//Flow Object Class::processing-instruction")

(declare-characteristic preserve-sdata?
  "UNREGISTERED::James Clark//Characteristic::preserve-sdata?"
  #t)

(define (copy-attributes #!optional (nd (current-node)))
  (let loop ((atts (named-node-list-names (attributes nd))))
    (if (null? atts)
        '()
        (let* ((name (car atts))
               (value (attribute-string name nd)))
          (if value
              (cons (list name value)
                    (loop (cdr atts)))
              (loop (cdr atts)))))))

(default (if (node-property 'momitend (current-node))
		(make empty-element attributes: (copy-attributes))
		(make element attributes: (copy-attributes))))

(element HTML
    (make sequence
	(make document-type 
		name: "ARTICLE" 
		public-id: "-//Davenport//DTD DocBook V3.0//EN")
	(process-children)))

(default 
  (let* ((old-gi (gi (current-node)))
		 (new-gi
		  (case old-gi
			(("HR") empty-sosofo)
			(("BR") empty-sosofo)
			(("PRE") "ProgramListing")
			(("OL") "OrderedList")
			(("UL") "ItemizedList")
			(("EM")  "Emphasis")
			(("I")  "Emphasis")
			(("STRONG")  "Emphasis")
			(("B")  "Emphasis")
			(("TT") "Command")
			(("P") "Para")
			(("MENU") "ItemizedList")
			(else old-gi))))
	(make element
	  gi: new-gi
	  attributes: (copy-attributes))))

(element article (make element))

(element title (make element))

(element head
    (make element gi: "ArtHeader"))

(element body
        (make element gi: "Sect1"))

(element li
  (make element gi: "ListItem"
		(make element gi: "Para"
			  (process-children))))

(element H1
  (make element gi: "Sect2"
		(make element gi: "Title"
			  (process-children))))

(element H2
  (make element gi: "Sect3"
		(make element gi: "Title"
			  (process-children))))

(element H3
  (make element gi: "Sect4"
		(make element gi: "Title"
			  (process-children))))

(element heading
    (make element gi: "Title"))

(element tt
    (make element gi: "Literal"
	attributes: `(("remap" "tt")))) ;; fixme

(element tscreen (process-children)) ; FIXME

(element li
   (make element gi: "ListItem" 
	(make element gi: "Para")))

(element URL
    (make element gi: "ULink"
	  attributes: `(("URL" ,(attribute-string "URL")))
	  (if (attribute-string "NAME")
		(literal (attribute-string "NAME"))
		(literal (attribute-string "URL")))))

(element IMG
   (make element gi: "Inlinegraphic"
        attributes: `(("Fileref" ,(attribute-string "SRC"))
                      (copy-attributes)))) 

(element A
    (if
        (attribute-string "HREF")
        (make element gi: "Ulink"
               attributes: `(("URL" ,(attribute-string
                              "HREF"))(copy-attributes))) 
        (make element gi: "Anchor"
               attributes: `(("ID" ,(attribute-string "NAME"))))))

(element label 
   (make empty-element gi: "Anchor"
	attributes: (copy-attributes)))

(element bf
    (make element gi: "Literal"
		  attributes: `(("remap" "bf"))))

(element quotep (process-children))


(element dl
   (make element gi: "GlossList"
	(process-matching-children "DT")))

(define (get-sibs)
    (let loop ( (rest (follow (current-node)))
		(accum (empty-sosofo)))
	(let ( (tag (gi (node-list-first rest))))
	    (if (or (not tag)
		    (string=? tag "DT"))
		 accum
		(loop (node-list-rest rest)
		    (sosofo-append accum 
			(process-node-list 
			    (node-list-first rest))))))))

(element DT
   (make element gi: "GlossEntry"
        (make element gi: "GlossTerm")
        (make element gi: "GlossDef" 
	     (get-sibs))))

</style-specification-body>
</style-specification>
</style-sheet>
